﻿(function () {
"use strict";
WinJS.Namespace.define("FinanceAppJS.Controls", {
CurrencyConverterInitDataProvider: WinJS.Class.define(function () {
this._roaming = FinanceAppJS.Roaming.CurrencyConverter.getInstance();
}, {
_roaming: null,
getInitData: function getInitData() {
var roamingData = this._roaming.readFromRoaming();
if (!roamingData || (!roamingData.amount && !roamingData.toCurrencies)) {
this._roaming.writeToRoaming(this.getDataFromConfiguration());
}
roamingData = this._roaming.readFromRoaming();
return roamingData;
},
getDataFromConfiguration: function getDataFromConfiguration() {
var data = {};
var configData = FinanceAppJS.Globalization.getTopConvertedCcysForccy(FinanceAppJS.Globalization.getDefaultCurrency());
data.toCurrencies = configData ? configData.topCurrencies : [];
data.amount = configData ? configData.amount : 1;
return data;
},
}, {
_instance: null,
getInstance: function getInstance() {
if (FinanceAppJS.Controls.CurrencyConverterInitDataProvider._instance === null) {
FinanceAppJS.Controls.CurrencyConverterInitDataProvider._instance = new FinanceAppJS.Controls.CurrencyConverterInitDataProvider();
}
return FinanceAppJS.Controls.CurrencyConverterInitDataProvider._instance;
}
})
});
})();
