﻿(function () {
'use strict';
function writetoCurrenciesToRoaming(listElmWin) {
var tilesCount = parseInt(listElmWin._cachedCount);
var toCurrencies = new Array();;
for (var cnt = 0; cnt < tilesCount - 1; cnt++) {
var binding = listElmWin.itemDataSource.createListBinding();
binding.fromIndex(cnt).then(function (item) {
toCurrencies.push(item.data.tileData.currencyCode);
binding.release();
});
}
FinanceAppJS.Roaming.CurrencyConverter.getInstance().setField(FinanceAppJS.Roaming.CurrencyConverter.toCurrencies, toCurrencies);
}
function addCcyToRoaming(ccy) {
if (!ccy) return;
var roamingData = FinanceAppJS.Roaming.CurrencyConverter.getInstance().readFromRoaming();
var toCurrencies = roamingData.toCurrencies;
toCurrencies.unshift(ccy);
FinanceAppJS.Roaming.CurrencyConverter.getInstance().setField(FinanceAppJS.Roaming.CurrencyConverter.toCurrencies, toCurrencies);
}
function listSelectionHandler(eventInfo, data) {
var btnClearSelection = data.btnClearSelection;
var reorderButtons = data.btnReorderButtons;
var listElmWin = data.listElmWin;
var ipage = data.ipage;
var ccyListActionEdgyControl = ipage.bottomEdgy.winControl;
if (reorderButtons) {
WatchListManage.handleMoveButtonsVisibility(listElmWin, reorderButtons);
}
if (data.currCount === 0) {
if (reorderButtons) {
WinJS.Utilities.addClass(reorderButtons, "hide");
}
var secTileCallback = function () {
ccyListActionEdgyControl.sticky = false;
ccyListActionEdgyControl.hide();
};
if (!ccyListActionEdgyControl.hidden) {
secTileCallback();
}
}
else {
if (data.currCount === 1) {
/*reorder buttons are displayed when more than one stock */
var stkTilesLength = parseInt(listElmWin._cachedCount) - 1;
if (stkTilesLength > 1) {
if (reorderButtons) {
WinJS.Utilities.removeClass(reorderButtons, "hide");
}
}
WinJS.Utilities.addClass(btnClearSelection, "hide");
listElmWin.selection.getItems().then(function (items) {
var item;
if (!items || !items.length || !(item = items[0].data.tileData)) {
return;
}
var tileData = items[0].data.tileData;
});
}
}
if (data.prevCount < data.currCount) { // item selected            
if (data.currCount > 1) {
WinJS.Utilities.removeClass(btnClearSelection, "hide");
}
if (ccyListActionEdgyControl.hidden) {
ccyListActionEdgyControl.sticky = true;
ccyListActionEdgyControl.show();
}
}
msSetImmediate(
function () {
if (data.currCount > 1) {
btnClearSelection.tabIndex = 0;
}
});
data.prevCount = data.currCount;
}
function itemInvokedHandler(itemInfo, listElmWin, pageId, quickSearchLocal) {
if (itemInfo && listElmWin) {
listElmWin.selection.clear();
var binding = listElmWin.itemDataSource.createListBinding();
binding.fromIndex(itemInfo.detail.itemIndex).then(function (item) {
var tileData = item.data.tileData;
if (WatchListManage.isAddTile(tileData)) {
PlatformJS.Services.instrumentation.incrementInt32(FinanceAppJS.Constants.Instrumentation.InstrumentationDataSetId, FinanceAppJS.Constants.Instrumentation.To_Currency_List_AddTile_Click, 1);
quickSearchLocal.showQuickSearch();
}
binding.release();
});
}
}
function attachBasicListEvents(ipage, listElm, btnClearSelection, btnReorderButtons, optionItem, quickSearchLocal) {
var listElmWin = listElm.view;
var that = ipage;
btnClearSelection.addEventListener("click", function () {
FinanceAppJS.Telemetry.FlightRecorder.LogUserEvent(
FinanceAppJS.Telemetry.FlightRecorder.GetPageId(WinJS.Navigation.location.channelId),
FinanceAppJS.Telemetry.Constants.Cluster.BOTTOMEDGY,
FinanceAppJS.Telemetry.Constants.BtmEdgyBtn.CLEARSEL,
"");
listElmWin.selection.clear();
}, false);
listElm.addEventListener("selectionchanging", function (eventInfo) {
if (eventInfo) {
WatchListManage.preventDefaultForAddTile(listElmWin.itemDataSource, eventInfo.detail.newSelection.getIndices(), eventInfo);
}
});
listElm.addEventListener("selectionchanged", function (eventInfo) {
var data = {
currCount: _gSelectedItemCountCurrent,
prevCount: _gSelectedItemCountPrev,
listElmWin: that._listElmWin,                
btnReorderButtons: btnReorderButtons,
btnClearSelection: btnClearSelection,                
ipage: that,
};
listSelectionHandler(eventInfo, data);
_gSelectedItemCountCurrent = data.currCount;
_gSelectedItemCountPrev = data.prevCount;
});
listElm.addEventListener("iteminvoked", function (itemInfo) {
if (itemInfo) {
itemInvokedHandler(itemInfo, listElmWin, optionItem.PageId, quickSearchLocal);
}
});
if (that.bottomEdgy && listElmWin) {
that.bottomEdgy.addEventListener("beforehide", function () {
listElmWin.selection.clear();
}, false);
}
var noOfTiles = (listElmWin._cachedCount - 1);
}
WinJS.Namespace.define("ToCurrencyConverterListManager", {
listSelectionHandler: listSelectionHandler,
itemInvokedHandler: itemInvokedHandler,
attachBasicListEvents: attachBasicListEvents,
writetoCurrenciesToRoaming: writetoCurrenciesToRoaming,
addCcyToRoaming: addCcyToRoaming,
});
})();