﻿(function () {
'use strict';
function getHomePageTemplates() {
return WinJS.UI.Fragments.render("/shared/html/templates.html").then(function (templateFragment) {
return WinJS.UI.processAll(templateFragment).then(function () {
var templates = {};
templates['genericStockTemplate'] = templateFragment.querySelector('#genericStockTemplate');
templates['groupHeaderTemplate'] = templateFragment.querySelector('#headerTemplate');
templates['avgRatesAnimatedItemTemplate'] = templateFragment.querySelector('#avgRatesAnimatedItemTemplate');
templates['avgRatesGroupHeaderTemplate'] = templateFragment.querySelector('#avgRatesGroupHeaderTemplate');
return templates;
},
function (error) {
return null;
});
}
,
function (error) {
return null;
});
}
function getWatchListTemplates() {
return WinJS.UI.Fragments.render("/shared/html/WatchListItemTemplate.html").then(function (templateFragment) {
return WinJS.UI.processAll(templateFragment).then(function () {
var templates = {};
templates['stockItemTemplate'] = templateFragment.querySelector('#stockItemTemplate');
return templates;
},
function (error) {
return null;
});
}
,
function (error) {
return null;
});
}
function getRatesTemplates() {
return WinJS.UI.Fragments.render("/shared/html/RatesTemplates.html").then(function (templateFragment) {
return WinJS.UI.processAll(templateFragment).then(function () {
var templates = {};
templates['avgRatesAnimatedItemTemplate'] = templateFragment.querySelector('#avgRatesAnimatedItemTemplate');
templates['avgRatesGroupHeaderTemplate'] = templateFragment.querySelector('#avgRatesGroupHeaderTemplate');
return templates;
},
function (error) {
return null;
});
}
,
function (error) {
return null;
});
}
WinJS.Namespace.define("templateProvider", {
getHomePageTemplates: getHomePageTemplates,
watchListTemplates: getWatchListTemplates
});
})();