﻿(function () {
"use strict";
WinJS.Namespace.define("NewsJS.Personalization",
{
Utilities: WinJS.Class.mix(WinJS.Class.define(function (options) {
}, {
}, {
mySourcesKey: "mySources",
myTopicsKey: "myTopics",
cnpItemsKey: "appexNewsCnPItem",
cnpHeadlineKey: "appexNewsCnPData",
maxCnPItems: 1024, // use large number as no limit.
supportTrends: true,
maxTrendingItems: 60,
todayMyItemsTemplate: "todayMyItemsTemplate",
todayMyItemsTemplateImageOnly: "todayMyItemsTemplateImageOnly",
todayMyItemsTemplateRss:"todayMyItemsTemplateRss",
todayMyItemsTrendsTemplateTextOnly: "todayMyItemsTrendsTemplateTextOnly",
todayMyItemsTrendsTemplate: "todayMyItemsTrendsTemplate",
myItemsAddTile: "myItemsAddTile",
tileSizeLarge: 290,
tileSizeSmall: 140,
tileType: {
Customize: "Customize",
Featured: "Featured",
SeeMore: "SeeMore",
AddMore: "AddMore",
},
tileSize: {
Large: "Large",
Wide: "Wide",
Small: "Small"
},
sourceType: {
InternationalBingDaily: "InternationalBingDaily",
},
selectionPageFormat: {
FORMAT_CLUSTER: "Cluster",
FORMAT_SOURCE: "Source",
},
selectionPageFeature: {
TYPE_SOURCES: "Sources",
TYPE_TOPICS: "Topics",
TYPE_TOPICS_FLAT: "Topics_Flat",
TYPE_INTERNATIONAL: "International",
TYPE_CATEGORIES: "Categories",
},
imageConverter: WinJS.Binding.converter(function (thumbnail) {
if (thumbnail && thumbnail.url) {
return "block";
}
else {
return "none";
}
}),
tabOrderConverter: WinJS.Binding.converter(function (id) {
var trendsDiv = WinJS.Utilities.query(".myTrendsList", document.body);
var maxItemToShow = parseInt(trendsDiv.getAttribute("maxItemToShow"));
if (id < maxItemToShow) {
return 0;
}
return -1;
}),
}), WinJS.Utilities.eventMixin),
});
})();
