﻿/* <DEBUG name="PAGE_LOAD_TIME"> Please uncomment the code for displaying page load time on startup */
(function () {
'use strict';
var oldOnPageLoadComplete = FinanceAppJS.FinanceBasePage.prototype.onVisibleAreaLoad;
var oldOnNavigateAway = FinanceAppJS.FinanceBasePage.prototype.onNavigateAway;
FinanceAppJS.FinanceBasePage.prototype.onVisibleAreaLoad = function () {
var TIME = performance.now();
window.STARTTIME = window.STARTTIME || 0;
var DELTA = TIME - window.STARTTIME;
WinJS.Application.local.exists("LoadTimes.txt").then(function (exists) {
var promise = exists ? WinJS.Application.local.readText("LoadTimes.txt", null) : WinJS.Promise.as("");
return promise.then(function (text) {
return WinJS.Application.local.writeText("LoadTimes.txt", text + DELTA.toFixed(2) + "\t\n");
});
});
var clusters = Object.keys(this.clusterControlsMap);
var rendered = this._clusterRenderedList, msgBar;
clusters = clusters.map(function (c) { return rendered[c] ? "[" + c + "]" : c; });
(msgBar = new CommonJS.MessageBar(DELTA.toString() + " : " + clusters.join(" "), { autoHide: false })).show();
setTimeout(function () { msgBar.hide(); }, 5000);
oldOnPageLoadComplete.call(this);
};
FinanceAppJS.FinanceBasePage.prototype.onNavigateAway = function () {
window.STARTTIME = performance.now();
oldOnNavigateAway.call(this);
};
})();
/* </DEBUG name="PAGE_LOAD_TIME"> */