﻿(function () {
"use strict";
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.Cluster', {
CONSTITUENT: "Index Constituents",
MOVERS: "Movers",
WORLDMARKET: "World Market",
CURRENCIES: "Currencies",
COMMODITIES: "Commodities",
BONDS: "Bonds",
CHART: "Charts",
INDEXCHART: "Indices Chart",
STOCKCHART: "Stock Chart",
ETFCHART: "ETF Chart",
FUNDCHART: "Fund Chart",
FUNDPICKS: "Fund Picks",
HERO: "Hero",
WATCHLIST: "Watchlist Items",
WATCHLISTITEMS: "Watchlist Items",
VIDEO: "Video",
NEWS: "News",
SOURCES: "Sources",
ACROSSMARKET: "Across the Market",
COMPANYPROFILE: "Company Profile",
TOOLS: "Tools",
TOOLITEMS: "Tool Items",
MAJORCURRENCIES: "Currencies",
BOTTOMEDGY: "App-Bar",
MONEY: "Money",
FROMCURRENCY: "From Currency",
TOCURRENCY: "To Currency",
FEATUREDCLUSTER: "Featured Cluster",
TOPINDICES: "Top Indices",
WORLDINDICES: "World Indices",
RIGHTCLICKSELECT: "Item Selection",
IDXMOVERS: "Index Movers",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.AppUtility', {
PINTILEMSG: "Pin Tile Popup",
PINTILESTART: "Pin Tile Started",
TOPBARMSG: "Nav-Bar Message",
FLYOUT: "FlyOut Display",
SEARCHCHARM: "Search Charm",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.BtmEdgyBtn', {
HELP: "Help",
PIN: "Pin to Start",
UNPIN: "UnPin from Start",
ADD: "Add",
REMOVE: "Tile Remove button",
CLEARSEL: "Clear Selection",
VIEWSEL: "View Mode Selector",
VUBYLIST: "View By List",
VUBYTILE: "View By Tile",
MOVEUP: "Move Up",
MOVEDOWN: "Move Down",
SORT: "Sort",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.Location', {
TABLE: "Table",
TABLEROW: "Table Row",
TILE: "Tile",
CLUSTERHEADER: "Cluster Header",
IDXMOREBTN: "Index details",
CLEARBTN: "Clear",
SEARCHQUOTE: "Search Quote",
INDEXSELECTOR: "Index Selector",
HEROINDEX: "Index Tiles",
CHARTRANGESELECTOR: "Date Range",
CHARTTABLESELECTOR: "Chart Table Selector",
CLUSTERITEM: "Cluster Tile",
NEWSITEM: "News Item",
HERONEWS: "News Title",
BUTTON: "Button",
READMOREBUTTON: "Read More Button",
MODESELECTOR: "Mode Selector",
CALCBUTTON: "Calculate Button",
HELP: "Help",
CHARTCANVAS: "Chart Canvas",
TEXTBOX: "Textbox",
LISTBOX: "Listbox",
CCYDROPDWN: "Currency Drop Down",
ADD: "Add",
APPBARIVK: "App-Bar Invoke",
APPBARRVK: "App-Bar Revoke",
CCYCONVERTER: "Currency Converter",
ECV: "ECV",
PINNEDTILE: "Pinned Tile",
EXCHSELECTOR: "Exchange Selector",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.Page', {
INDEXDETAILS: "Index Details page",
MARKET: "Market page",
MARKETTODAY: "Today page",
WORLDMARKET: "World Markets page",
WATCHLIST: "Watchlist Items",
MARKETMOVERS: "Market Movers page",
STOCKDETAILS: "Stock Details page",
TOOLS: "Tools",
FUNDBROWSE: "Funds Browse",
FUNDPICKS: "Fund Picks",
FUNDDETAILS: "Fund Details",
RATES: "Rates",
ENTITYNEWSPANO: "News by Category page",
ENTITYMONEYPANO: "Money page",
CURRENCIES: "Currencies",
CURRENCYCONVERTER: "Currency Converter",
SINGLECLUSTERNEWSPAGE: " News page",
SINGLECLUSTERMONEYPAGE: " Money page",
ETF: "ETF Details page",
MOGOSCREEN: "Mogo Screen",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.WatchListAction', {
WATCHLISTMODIFY: "Watchlist Items",
ADD: "Symbol Added",
REMOVE: "Symbol Removed",
});
WinJS.Namespace.define('FinanceAppJS.Telemetry.Constants.NavMethod', {
PINTILE: "Secondary Tile",
SEARCHCHARM: "Search Charm",
});
})();