﻿(function () {
"use strict";
WinJS.Namespace.define("CommonJS.News.EntityClusterConfig.WSJ",
{
TemplateClassMap:
{
WSJRegular: {
classID: "WSJRegular",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "News",
templateList: [
"WSJ_Small_Square_1col_2row",
"WSJ_None_1col_2row"
]
},
WSJLead: {
classID: "WSJLead",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 5,
isDefault: false,
type: "News",
templateList: [
"WSJ_Large_Landscape_2col_4row",
"WSJ_None_2col_2row"
]
},
WSJLeadVideo: {
classID: "WSJLeadVideo",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 5,
isDefault: false,
type: "News",
templateList: [
"WSJ_Large_Video_2col_4row",
"WSJ_None_2col_2row"
]
},
WSJVideo: {
classID: "WSJVideo",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "News",
templateList: [
"WSJ_Medium_Video_1col_2row"
]
},
WSJPhoto: {
classID: "WSJPhoto",
snippetMin: 0,
aspectRatioMin: 0,
aspectRatioMax: 0,
isDefault: false,
type: "News",
templateList: [
"WSJ_Photos_Large_Landscape_2col_4row"
]
}
},
TemplateDefinitions:
{
WSJ_Large_Landscape_2col_4row: {
classID: "WSJ_Large_Landscape_2col_4row",
thumbnailHeight: 350,
thumbnailWidth: 590,
height: 59,
width: 61,
lastResort: false
},
WSJ_None_2col_2row: {
classID: "WSJ_None_2col_2row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 29,
width: 61,
lastResort: true
},
WSJ_Small_Square_1col_2row: {
classID: "WSJ_Small_Square_1col_2row",
thumbnailHeight: 100,
thumbnailWidth: 100,
height: 29,
width: 30,
lastResort: false
},
WSJ_None_1col_2row: {
classID: "WSJ_None_1col_2row",
thumbnailHeight: 0,
thumbnailWidth: 0,
height: 29,
width: 30,
lastResort: true
},
WSJ_Large_Video_2col_4row: {
classID: "WSJ_Large_Video_2col_4row",
thumbnailHeight: 350,
thumbnailWidth: 590,
height: 59,
width: 61,
lastResort: false
},
WSJ_Medium_Video_1col_2row: {
classID: "WSJ_Medium_Video_1col_2row",
thumbnailHeight: 157,
thumbnailWidth: 280,
height: 29,
width: 30,
lastResort: false
},
WSJ_Photos_Large_Landscape_2col_4row: {
classID: "WSJ_Photos_Large_Landscape_2col_4row",
thumbnailHeight: 400,
thumbnailWidth: 590,
height: 59,
width: 61,
lastResort: true
}
},
RulesList:
[
{
type: "Frequency",
count: 1,
columns: 8,
templateList: [
"WSJ_Large_Landscape_2col_4row"
]
},
{
type: "Frequency",
count: 1,
columns: 8,
templateList: [
"WSJ_None_2col_2row"
]
}
]
});
})();
